#include"kraluk.h"

void nactigbarvy ()
{
  kq_color *voda1, *voda2,  *voda3;
  zed = pridejbarvu("#000000", 1);
  zem = pridejbarvu("#00FF00", 0);
  voda1 = pridejbarvu("#AB9AFF", 0);
  voda2 = pridejbarvu("#846CFF", 0);
  voda3 = pridejbarvu("#6243FF", 0);
  breh = pridejbarvu("#AC4900", 0);
  nebvoda1 = pridejbarvu("#0000FF", 0);
  nebvoda2 = pridejbarvu("#0000BF", 0);
  nebvoda3 = pridejbarvu("#000080", 0);
  nebvoda4 = pridejbarvu("#000040", 0);
  ohen = pridejbarvu("#FF9600", 0);
  ohen->prichfunc = shor;
  pridejbarvu("None", 0)->z = -1000;
  dosahpredmet = pridejbarvu("#00BB00", 0);
  dosahpredmet->z = -10;
  pridejbarvu("#6B1E77", 0)->prichfunc = barvapolic;

  skalopad1 = pridejbarvu("#CCCC00", 0);
  skalopad2 = pridejbarvu("#E6E600", 0);
  skalopad3 = pridejbarvu("#FFFF00", 0);
  skalopad1->prichfunc = skalopad2->prichfunc = skalopad3->prichfunc = skalopada;

  breh->prichfunc = paddovody;

  voda1->prichfunc = brodi1;
  voda2->prichfunc = brodi2;
  voda3->prichfunc = brodi3;
  nebvoda1->prichfunc = topise;
  nebvoda2->prichfunc = topise;
  nebvoda3->prichfunc = topise;
  nebvoda4->prichfunc = topise;

  voda1->odchfunc = sucho;
  voda2->odchfunc = sucho;
  voda3->odchfunc = sucho;
  nebvoda1->odchfunc = sucho;
  nebvoda2->odchfunc = sucho;
  nebvoda3->odchfunc = sucho;
  nebvoda4->odchfunc = sucho; 
}

kq_color *aktupixel ()
{
  if(!panacek) return NULL;
  return mappixel(mapa, panacek->x, panacek->y);
}

void nuluj_z (kq_postava *post, kq_color *b1, kq_color *b2)
{
  post_z(post, 0,0,0);
}

void normal_z (kq_postava *post, kq_color *b1, kq_color *b2)
{
  post_z(post, 0,1, 0.5);
}

void sucho (kq_postava *post, kq_color *stara, kq_color *nova)
{
  if(nova->prichfunc == topise) return;

  zmenanip(panacek, chozeni);
  if(stara->prichfunc == topise){
    ovlpost = post;
    post->xx = post->yy = 0;
    normal_z(post, stara, nova);
    post->tim->cas = 2;
  }
}

static void dovody (kq_animpost *anip)
{
  if(panacek->animace == brnanip){
    panacek->tim->cas = 3;
    popup_info("vstup uhas");
    predmetnull(brneni);
  }
  zmenanip(panacek, anip);
}

void brodi1 (kq_postava *post, kq_color *nova, kq_color *stara)
{ dovody(vevode1); }

void brodi2 (kq_postava *post, kq_color *nova, kq_color *stara)
{ dovody(vevode2); }

void brodi3 (kq_postava *post, kq_color *nova, kq_color *stara)
{ dovody(vevode3); }

void plave (kq_postava *post, kq_color *nova, kq_color *stara)
{ dovody(plavani); }

void topise (kq_postava *post, kq_color *nova, kq_color *stara)
{
  if(stara->prichfunc != topise){
    dovody(topeni);
    post->tim->cas = 1;
    nuluj_z(post, stara, nova);
    ovlpost = NULL;
  }

  if(nova == nebvoda1 || nova == nebvoda2) post->yy = -1;
  if(nova == nebvoda2 || nova == nebvoda3) post->xx = 1;
  if(nova == nebvoda3 || nova == nebvoda4) post->yy = 1;
  if(nova == nebvoda4 || nova == nebvoda1) post->xx = -1;
}

void paddovody (kq_postava *post, kq_color *nova, kq_color *stara)
{
  int i, x, y, smer;
  kq_color *mpxl;

  for(i=0; i<mapa.sirka; i++){
    x=post->x+i;
    y=post->y+i;
    smer = NAHORU;
    for(;;){
      mpxl = mappixel(mapa, x, y);
      if(mpxl && mpxl->prichfunc == topise){
	post->x = x;
	post->y = y;
	topise (post, mpxl, nova);
	if(stara == zem || stara == most_col) popup_info("danger water");
	return;
      }
      if(smer == NAHORU && y == post->y-i) smer = VLEVO;
      if(smer == VLEVO && x == post->x-i) smer = DOLU;
      if(smer == DOLU && y == post->y+i) smer = VPRAVO;
      if(smer == VPRAVO && x == post->x+i) break;

      switch(smer){
      case NAHORU: y--; break;
      case VLEVO: x--; break;
      case DOLU: y++; break;
      case VPRAVO: x++; break;
      }
    }
  }

  warning("paddovody: voda nenalezena");
}

void bachakytky (kq_postava *post, kq_color *nova, kq_color *stara)
{
  popup_info("flowers warn");
}

void prich_most (kq_postava *post, kq_color *nova, kq_color *stara)
{
  if(!most_sm){
    warning("prich_most: most_sm neni nacteny");
    return;
  }

  unhidesubmap(most_sm);
  post_z(post, 0,0,500);
}

void odch_most (kq_postava *post, kq_color *stara, kq_color *nova)
{
  int x, y;

  if(!most_sm){
    warning("odch_most: most_sm neni nacteny");
    return;
  }

  hidesubmap(most_sm);
  normal_z(post, stara, nova);

  if(nova == breh){
    x = post->x;
    y = post->y;

    while(smpixel(most_sm,x,y) == breh) y++;
    y--;
    if(y > post->y) post->y = y;
  }
}

void teleportuj ()
{
  if(telepost == NULL){
    popup_info("teleport");
    ovlpost = NULL;
    panacek->xx = panacek->yy = 0;
    panacek->barvy = 0;
    telepost = vytvorpost(panacek->x, panacek->y, NAHORU, 0, 0, 0, 0);
    normal_z(telepost, NULL, NULL);
    telepost->z += 0.2;
    telepost->barvy = 0;
    if(hvezdicka->inv) zmenanip(telepost, teleanip2);
    else zmenanip(telepost, teleanip);
  }
  else if(telepost->smer == NAHORU){
    if(telepost->animstav < 14){
      telepost->animstav++;
      if(telepost->animstav == 9) hidepost(panacek);
    }
    else if(!telepost->hide) hidepost(telepost);
    else{
      if(hvezdicka->inv){
	popup_info("hvezda pryc");
	predmetnull(hvezdicka);
	kql_square(panacek, pol[6][4], 80, 20, 0, 0, 0);
      }
      else kql_square(panacek, skala1, 83, 64, 0, 0, 0);
      znak = 0;
      posunpost(telepost, panacek->x, panacek->y);
      telepost->smer = DOLU;
    }
  }
  else{
    if(telepost->hide) unhidepost(telepost);
    else if(telepost->animstav > 0){
      telepost->animstav--;
      if(telepost->animstav == 9) unhidepost(panacek);
    }
    else{
      znictimer(aktutimer);
      teletim = NULL;
      znicpost(telepost);
      telepost = NULL;
      panacek->barvy = 1;
      ovlpost = panacek;
    }
  }
  if(telepost) zmenapost(telepost);
}

void telestart (kq_postava *post, kq_color *nova, kq_color *stara)
{
  if(teletim){
    znictimer(teletim);
    warning("teletim neni NULLovy");
  }
  teletim = vytvortimer(&teleportuj, pinnull, 50+random()%200, -20, 0, 0, 0);
  teletim->cas = 4;
}

void teleend (kq_postava *post, kq_color *stara, kq_color *nova)
{
  if(teletim) znictimer(teletim);
  else warning("teletim je NULLovy");
  teletim = NULL;
}

void skalopada (kq_postava *post, kq_color *nova, kq_color *stara)
{
  if(post != panacek) return;

  if(aktupol == pol[0][1]){
    normal_z(panacek, NULL, NULL);
    zmenanip(panacek, chozeni);
    panacek->y = 52;
    if(jezibaba) jezichytej();
    return;
  }

  if(panacek->animace == lezeni){
    if(aktupol == skal_zebr1 && jezibaba && jezibaba->animace == jezianip){
      znicpost(jezibaba);
      jezinull();
      popup_info("pada z houp");
    }
    else popup_info("pada z zebriku");
  }
  else if(aktupol == pol[7][3]) popup_info("pada do diry");
  else if(aktupol == schody1 || aktupol == schody2) popup_info("pada ze schodu");
  else popup_info("pada ze skaly");

  if(post->animace == brnanip){
    post->tim->cas = 3;
    popup_info("pada brn");
    predmetnull(brneni);
  }

  zmenanip(post, padani);
  post->lokalni = 1;
  post->barvy = post->zdi = 0;
  post->xx = 0;
  post->yy = 3;
  post->xz = panacek->yz = 0;
  if(nova == skalopad1) post->z = -3;
  else if(nova == skalopad2) post->z = -1;
  else panacek->z = 1;
  ovlpost = NULL;
  panacek = NULL;
  if(jezibaba) jezivzdej();
}

void shor (kq_postava *post, kq_color *nova, kq_color *stara)
{
  if(post == jezibaba){
    jezishor();
    return;
  }

  if(post->animace != brnanip){
    popup_info("shorel jsi");
    ovlpost = NULL;
    vytvortimer(znicpost, pinpointer(panacek), 0, 100, 1, 0, 0);
    panacek = NULL;
    if(jezibaba) jezivzdej();
  }
}

void padejkokos (kq_postava *post, kq_color *nova, kq_color *stara)
{
  zmenprnazev(kokos, "kokrap");
  znicsubmap(kokos->post->submap);
  kokos->post->submap = NULL;
  kokos->pix_y = 85;
  kokos->sm_x = 21;
  kokos->sm_y = 102;
  vytvortimer(kokpadstep, pinnull, 1, -1, 46, 1, 0);
}

void kokpadstep ()
{
  kq_animpost *anip;

  if(aktutimer->opakovani == 0){
    anip = kokos->post->animace;
    zmenanip(kokos->post, nactianip(-50, -85, "kokrap", 1,0,1,0,1));
    posunpost(kokos->post, 0, 0);
    kokos->post->submap = prvsubmap;
    return;
  }
  if(aktutimer->opakovani == 20){
    vytvorsubmap(21, 102, 5, "kokrap", 1, 0);
    if(aktupixel() == zed){
      popup_info("kokos bum");
      znicpost(panacek);
      panacek = ovlpost = NULL;
    }
  }
  posunpost(kokos->post, 0, kokos->post->y+2);
}

void levchyt (kq_postava *post, kq_color *nova, kq_color *stara)
{
  if(lvistav) return;
  if(svicka->inv && svicka->stav){
    vytvorwidget(  5, 67,  62.2, nactikqXPM("kamenlev1", 1), 1, 0);
    vytvorwidget( 76, 66,  62.2, nactikqXPM("kamenlev2", 1), 1, 0);
    lvistav = 1;
    popup_info("zkamenel lev");
    znak = 'k';
    if(kaminek->inv){
      predmetnull(kaminek);
      kaminek->slovo->kontext++;
      kamen = vytvorpost(66, 91, NAHORU, 0, 0, 1, 0);
      zmenanip(kamen, nactianip(14, 21, "kamen", 1, 0, 1, 0, 1));
      normal_z(kamen, NULL, NULL);
      post_submap(kamen, "kamen", 18, 13, 5);
      popup_info("vypad kamen");
    }
  }
  else{
    popup_info("chytil lev");
    vytvortimer(znicpost, pinpointer(panacek), 0, 100, 1, 0, 0);
    panacek = NULL;
    ovlpost = NULL;
  }
}

void barvapolic (kq_postava *post, kq_color *nova, kq_color *stara)
{
  znak = 0;
  if(aktupol == pol[5][1]){
    kql_square(panacek, vdrevchal, panacek->x+5, -1, 0, 1, 1);
    znak = 0;
    popup_info("drevchal odmena");
  }
  else if(aktupol == lvi){
    popup_info("pada pred peklo");
    panacek->xx = panacek->yy = 0;
    kql_square(panacek, peklbrana, 95, 7, 0, 0, 0);
    lev->kontext--;
    znak = 0;
  }
  else if(aktupol == schody2){
    kql_square(panacek, pol[0][0], 80, 45, 0, 0, 0);
    znak = 'j';
    post_z(panacek, 0, 0, 10);
  }
  else if(aktupol == pol[0][0]){
    kql_square(panacek, schody2, 3, 14, 0, 0, 0);
    normal_z(panacek, NULL, NULL);
    znak = 0;
  }
  else if(aktupol == pol[4][3]){
    kql_square(panacek, vzamku1, 55, -1, 0, 1, 0);
    znak = 0;
  }
}

void predTV (kq_postava *post, kq_color *nova, kq_color *stara)
{
  popup_info("pred TV");
}
