#include<stdio.h>
#include<stdlib.h>
#include "defaults.h"
#include "types.h"
#include "pin.h"
#include "X.h"
#include "warning.h"
#include "mystring.h"
#include "window.h"
#include "loop.h"
#include "edit.h"
#include "post.h"
#include "popup.h"
#include "bindings.h"
#include "keyboard.h"

static XFontStruct *pfont;
static char *pstr;
static char **popvyber;
int aktuselect;
static int posunuti;
static int selvyska, selsirka, selpocet, sloupec;
static int sirka, vyska;
static Window pwin;
static GC pgc;

void loadpopupfont ()
{
  popup_small_font = XLoadQueryFont(display, POPUPSMALLFONT);
  popup_big_font = XLoadQueryFont(display, POPUPBIGFONT);
  if(popup_small_font == NULL && popup_big_font == NULL)
    error("cannot open %s font neither %s font", POPUPSMALLFONT, POPUPBIGFONT);

  if(popup_small_font == NULL){
    popup_small_font=popup_big_font;
    warning("cannot open %s font", POPUPSMALLFONT);
  }
  if(popup_big_font == NULL){
    popup_big_font=popup_small_font;
    warning("cannot open %s font", POPUPBIGFONT);
  }
}

static void vyberpfont ()
{
  if(win_sirka < POPUPBIGWIDTH) pfont = popup_small_font;
  else pfont = popup_big_font;
}

static int zalomstring (float fsirka, float fvyska, char *str)
{
  int i, j, k, x, y;
  int maxx;

  sirka = win_sirka*fsirka - (2*(POPRAMOKR+POPRAMSIR) + POPLOT + POPPOT);
  vyska = win_vyska*fvyska - (2*(POPRAMOKR+POPRAMSIR) + POPHOT + POPDOT);

  maxx = 0;

  y = 0;

  for(i=0; pstr[i];){
    x = 0;
    y += pfont->ascent + pfont->descent;
    if(y > vyska && i){
      y -= pfont->ascent+pfont->descent;
      break;
    }
    y += INTERLINESKIP;

    for(k=j=i;;x += XTextWidth(pfont, " ", 1)){
      while(pstr[i] && pstr[i] != ' ' && pstr[i] != '\n') i++;

      x += XTextWidth(pfont, &pstr[k], i-k);
      if(x > sirka){
	if(k == j){
	  sirka = x;
	  strncpy(pstr, str, i);
	  i=0;
	  maxx = 0;
	  y = 0;
	  break;
	}
	pstr[k-1] = '\n';
	i = k;
	break;
      }
      if(x > maxx){
	maxx = x;
      }

      if(pstr[i] == 0) break;
      if(pstr[i] == '\n'){
	i++;
	break;
      }      
      i++;
      k=i;
    }
  }

  pstr[i] = 0;
  for(i=0; pstr[i]; i++) if(pstr[i] == '~') pstr[i] = ' ';

  sirka = maxx;
  vyska = y-INTERLINESKIP;

  return i;
}

static void createpwin (float fx, float fy)
{
  int x, y;

  updateposts();

  sirka += 2*(POPRAMOKR+POPRAMSIR) + POPLOT + POPPOT;
  vyska += 2*(POPRAMOKR+POPRAMSIR) + POPHOT + POPDOT;

  x = (win_sirka-sirka)*fx;
  y = (win_vyska-vyska)*fy;

  pwin = XCreateSimpleWindow(display, win, x, y, sirka, vyska, 0,
			     BlackPixel(display,screen), WhitePixel(display,screen));

  pgc = XCreateGC(display, pwin, 0, NULL);

  XSetFont(display, pgc, pfont->fid);
  XSetForeground(display, pgc, BlackPixel(display,screen));
  XSetLineAttributes(display, pgc, POPRAMSIR, LineSolid, CapButt, JoinMiter);

  XSelectInput(display, pwin, ExposureMask);

  XMapWindow(display, pwin);
}

void oznacsel ()
{
  int x, y;

  x = ((aktuselect-posunuti) / selvyska) * (sloupec+INTERCOLUMNSKIP) +
    POPRAMOKR+POPRAMSIR+POPLOT;
  y = ((aktuselect-posunuti) % selvyska) * (pfont->ascent+pfont->descent+INTERLINESKIP) +
    POPRAMOKR+POPRAMSIR+POPHOT;

  if(pstr) y += pfont->descent+POPDOT+POPRAMSIR+POPHOT+pfont->ascent;

  XFillRectangle(display, pwin, pgc, x-SELECTOKR, y-SELECTOKR,
		 sloupec + 2*SELECTOKR,
		 pfont->ascent+pfont->descent+2*SELECTOKR);
  XSetForeground(display, pgc, WhitePixel(display,screen));
  y += pfont->ascent;
  XDrawString(display, pwin, pgc, x, y, popvyber[aktuselect], strlen(popvyber[aktuselect]));
  XSetForeground(display, pgc, BlackPixel(display,screen));
}  

void odoznacsel ()
{
  int x, y;

  x = ((aktuselect-posunuti) / selvyska) * (sloupec+INTERCOLUMNSKIP) +
    POPRAMOKR+POPRAMSIR+POPLOT;
  y = ((aktuselect-posunuti) % selvyska) * (pfont->ascent+pfont->descent+INTERLINESKIP) +
    POPRAMOKR+POPRAMSIR+POPHOT;

  if(pstr) y += pfont->descent+POPDOT+POPRAMSIR+POPHOT+pfont->ascent;

  XClearArea(display, pwin, x-SELECTOKR, y-SELECTOKR,
	     sloupec + 2*SELECTOKR,
	     pfont->ascent+pfont->descent + 2*SELECTOKR, 0);
  y += pfont->ascent;
  XDrawString(display, pwin, pgc, x, y, popvyber[aktuselect], strlen(popvyber[aktuselect]));
}  

void clearselect ()
{
  int x, y, s, v;

  x = POPRAMOKR + POPRAMSIR + POPLOT;
  y = POPRAMOKR + POPRAMSIR + POPHOT;
  if(pstr) y += pfont->ascent + pfont->descent + POPDOT + POPRAMSIR + POPHOT;

  s = (sloupec+INTERCOLUMNSKIP)*selsirka-INTERCOLUMNSKIP;
  v = (pfont->ascent+pfont->descent+INTERLINESKIP)*selvyska-INTERLINESKIP;

  XClearArea(display, pwin, x-SELECTOKR, y-SELECTOKR, s+2*SELECTOKR, v+2*SELECTOKR, 0);
}

void drawselect ()
{
  int i, x, y, starty;

  if(pstr) starty = 2*POPRAMSIR+2*POPHOT+POPLOT+POPRAMOKR
	     +2*pfont->ascent+pfont->descent;
  else starty = POPRAMSIR+POPHOT+POPRAMOKR+pfont->ascent;
  x = POPRAMOKR+POPRAMSIR+POPLOT;

  y = starty;

  for(i=posunuti; popvyber[i];){
    if(i == aktuselect) oznacsel();
    else XDrawString(display, pwin, pgc, x, y, popvyber[i], strlen(popvyber[i]));

    if((++i-posunuti) % selvyska) y += pfont->descent + INTERLINESKIP + pfont->ascent;
    else{
      if((i-posunuti) / selvyska >= selsirka) break;
      y = starty;
      x += sloupec + INTERCOLUMNSKIP;
    }
  }
}

void drawpopup (char seznam)
{
  int x, y, i, j;

  x = y = POPRAMOKR + POPRAMSIR/2;

  XDrawRectangle(display, pwin, pgc, x, y,
		 sirka - 2*POPRAMOKR - POPRAMSIR, vyska - 2*POPRAMOKR - POPRAMSIR);

  x = POPRAMOKR+POPRAMSIR+POPLOT;
  y = POPRAMOKR+POPRAMSIR+POPHOT+pfont->ascent;
  if(seznam){
    if(pstr){
      XDrawString(display, pwin, pgc, x, y, pstr, strlen(pstr));
      y += pfont->descent+POPDOT;
      if(selvyska) XFillRectangle(display, pwin, pgc, POPRAMOKR+POPRAMSIR, y,
				  sirka-2*POPRAMOKR-2*POPRAMSIR, POPRAMSIR);
      y += POPRAMSIR+POPHOT+pfont->ascent;
    }
    drawselect();
  }
  else{
    for(i=j=0; pstr[i]; i++){
      if(pstr[i] == '\n'){
	if(j != i) XDrawString(display, pwin, pgc, x, y, &pstr[j], i-j);
	j=i+1;
	y += pfont->descent + INTERLINESKIP + pfont->ascent;
      }
    }
    if(j != i) XDrawString(display, pwin, pgc, x, y, &pstr[j], i-j);
  }
}

char popupstring (float fsirka, float fvyska, float fx, float fy, char *str, char vypnout)
{
  int stringend;
  KeySym ks;
  char *ksname, ch;
  XEvent report;

  pstr = dupstr(str);
  vyberpfont();
  stringend = zalomstring(fsirka, fvyska, str);
  createpwin(fx, fy);

  for(;;){
    XNextEvent(display, &report);
    cekalose = 1;
    if(report.type == KeyPress){
      if(vypnout || report.xkey.keycode == KEY_ESC ||
	 report.xkey.keycode == KEY_ENTER ||
	 report.xkey.keycode == KEY_SPACE) break;
    }
    if(report.type == ButtonPress) break;
    if(report.type == Expose){
      if(report.xexpose.window == textwin) redrawtext();
      else if(report.xexpose.window == pwin) drawpopup(0);
      else warning("divne expose");
    }
  }

  XDestroyWindow(display, pwin); XFreeGC(display, pgc); free(pstr); mengraf = 1;

  if(report.type == KeyPress && report.xkey.keycode == KEY_ESC) return 0;

  if(vypnout && report.type == KeyPress &&
     report.xkey.keycode != KEY_ENTER && report.xkey.keycode != KEY_SPACE){

    XLookupString (&report.xkey, NULL, 0, &ks, NULL);
    if (ks != NoSymbol && (ksname = XKeysymToString (ks))
	&& dobind(ksname)) return 1;     // zkusim spustit klavesovou zkratku
    ch = xkeyznak(&report);
    if(ch) pripisznak(ch);  // nebo alespon pripsat zmacknuty znak do spodniho radku
    return 1;
  }

  if(str[stringend]) return popupstring(fsirka, fvyska, fx, fy, &str[stringend], vypnout);

  return 1;
}

static void spoctivyber (float fsirka, float fvyska)
{
  int x, nadpissirka;

  if(!popvyber[0]){
    selsirka = selvyska = 0;
    if(pstr){
      sirka = XTextWidth(pfont, pstr, strlen(pstr));
      vyska = pfont->ascent+pfont->descent;
    }
    else sirka = vyska = 0;

    return;
  }
  sirka = win_sirka*fsirka - (2*(POPRAMOKR+POPRAMSIR) + POPLOT + POPPOT);
  vyska = win_vyska*fvyska - (2*(POPRAMOKR+POPRAMSIR) + POPHOT + POPDOT);
  if(pstr){
    nadpissirka = XTextWidth(pfont, pstr, strlen(pstr));
    vyska -= POPHOT+pfont->ascent+pfont->descent+POPDOT+POPRAMSIR;
    if(nadpissirka > sirka) sirka = nadpissirka;
  }
  else nadpissirka = 0;

  sloupec = 0;
  for(selpocet = 0; popvyber[selpocet]; selpocet++){
    x = XTextWidth(pfont, popvyber[selpocet], strlen(popvyber[selpocet]));
    if(x > sloupec) sloupec = x;
  }

  selvyska = (vyska + INTERLINESKIP) / (pfont->ascent + pfont-> descent + INTERLINESKIP);
  if(selvyska > selpocet) selvyska = selpocet;
  if(selvyska < 1) selvyska = 1;
  vyska = selvyska * (pfont->ascent + pfont-> descent + INTERLINESKIP) - INTERLINESKIP;

  selsirka = (sirka + INTERCOLUMNSKIP) / (sloupec + INTERCOLUMNSKIP);
  if(selsirka > (selpocet-1)/selvyska) selsirka = (selpocet-1)/selvyska+1;
  if(selsirka < 1) selsirka = 1;
  sirka = selsirka * (sloupec + INTERCOLUMNSKIP) - INTERCOLUMNSKIP;
  if(sirka < nadpissirka){
    sloupec = (nadpissirka+INTERCOLUMNSKIP)/selsirka - INTERCOLUMNSKIP;
    sirka = nadpissirka;
  }

  if(aktuselect < 0) aktuselect = 0;
  if(aktuselect >= selpocet) aktuselect = selpocet-1;

  if(aktuselect < posunuti) posunuti = aktuselect;
  else if(aktuselect >= posunuti + selvyska*selsirka) posunuti = aktuselect-selvyska*selsirka+1;
  if(posunuti+selvyska*selsirka > selpocet) posunuti = selpocet-selvyska*selsirka;
  if(posunuti < 0) posunuti = 0;

  if(pstr) vyska += POPHOT+pfont->ascent+pfont->descent+POPDOT+POPRAMSIR;
}

void posunselect (int okolik)
{
  int naktu;

  if(okolik == 2) okolik = selvyska;
  else if(okolik == -2) okolik = -selvyska;

  naktu = aktuselect + okolik;
  if(naktu < 0) naktu = 0;
  else if(naktu >= selpocet) naktu = selpocet-1;

  if(naktu == aktuselect) return;

  if(naktu < posunuti || naktu >= posunuti+selvyska*selsirka){
    posunuti += okolik;
    if(posunuti < 0) posunuti = 0;
    if(posunuti+selvyska*selsirka > selpocet) posunuti = selpocet-selvyska*selsirka;

    clearselect();
    aktuselect = naktu;
    drawselect();
  }
  else{
    odoznacsel();
    aktuselect = naktu;
    oznacsel();
  }
}

void vytvorpsel (float fsirka, float fvyska, float fx, float fy,
		 char *nadpis, char **pole, int aktu, int posun)
{
  popvyber = pole;
  aktuselect = aktu;
  pstr = nadpis;
  posunuti = posun;

  vyberpfont();
  spoctivyber(fsirka, fvyska);
  createpwin(fx, fy);
}

void zruspsel ()
{
  XDestroyWindow(display, pwin);
  XFreeGC(display, pgc);
  mengraf = 1;
}

void popup_selpocet (int nsp)
{
  selpocet = nsp;
  posunuti = 0;
}

int popupselect (float fsirka, float fvyska, float fx, float fy,
		 char *nadpis, char **pole, int aktu, int *posun)
{
  if(!pole || !pole[0]){
    warning("empty popup select");
    return -1;
  }
  if(posun) posunuti = *posun;
  else posunuti = 0;

  vytvorpsel(fsirka, fvyska, fx, fy, nadpis, pole, aktu, posunuti);

  XEvent report;

  for(;;){
    XNextEvent(display, &report);
    cekalose = 1;
    if(report.type == KeyPress){
      if(report.xkey.keycode == KEY_ESC){
	aktuselect = -1;
	break;
      }
      else if(report.xkey.keycode == KEY_ENTER) break;
      else if(report.xkey.keycode == KEY_UP)    posunselect(-1);
      else if(report.xkey.keycode == KEY_DOWN)  posunselect(1);
      else if(report.xkey.keycode == KEY_LEFT)  posunselect(-2);
      else if(report.xkey.keycode == KEY_RIGHT) posunselect(2);
      //printf("%d\n", report.xkey.keycode);
    }
    if(report.type == ButtonPress){
      aktuselect = -1;
      break;
    }
    if(report.type == Expose){
      if(report.xexpose.window == textwin) redrawtext();
      else if(report.xexpose.window == pwin) drawpopup(1);
      else warning("divne expose");
    }
  }

  zruspsel();

  if(posun) *posun = posunuti;
  return aktuselect;
}
